import React, { useCallback, useState } from 'react';
import ReactDOM from 'react-dom';
import { DEFAULT_POPOVER_WIDTH } from '../../../constants';
import { getAutoPlacing, getRect } from './helpers';
import { Arrow, Body, Container, Content } from './styles';
export var Popover = function (_a) {
    var placing = _a.placing, isOpen = _a.isOpen, children = _a.children, anchorElement = _a.anchorElement, width = _a.width, _b = _a.offset, offset = _b === void 0 ? 12 : _b, className = _a.className, disableAutoPlacing = _a.disableAutoPlacing, popoverRoot = _a.popoverRoot;
    var _c = useState(0), containerWidth = _c[0], setContainerWidth = _c[1];
    var _d = useState(null), containerRect = _d[0], setContainerRect = _d[1];
    var _e = useState(false), breachedLeftSide = _e[0], setBreachedLeftSide = _e[1];
    var rect = getRect(anchorElement);
    var autoPlacing = isOpen && disableAutoPlacing
        ? placing
        : getAutoPlacing(rect, placing, width || containerWidth);
    var containerRef = useCallback(function (node) {
        var nodeRect = getRect(node);
        setContainerRect(nodeRect);
        if (node) {
            if (nodeRect.left < 0) {
                setContainerWidth(nodeRect.width + nodeRect.left);
                setBreachedLeftSide(true);
            }
            else {
                setContainerWidth(node.clientWidth || DEFAULT_POPOVER_WIDTH);
            }
        }
    }, []);
    if (isOpen) {
        return ReactDOM.createPortal(React.createElement(Container, { offset: offset, width: breachedLeftSide ? containerWidth : width, placing: autoPlacing, rect: rect, className: className, ref: containerRef, breached: breachedLeftSide, containerRect: containerRect },
            React.createElement(Body, { placing: autoPlacing },
                React.createElement(Arrow, { placing: autoPlacing, breached: breachedLeftSide, rect: rect, containerRect: containerRect }),
                React.createElement(Content, null, children))), popoverRoot || document.body);
    }
    return null;
};
