var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React, { useState } from 'react';
import { Icon } from "../../components/elements/Icon";
import { Popover } from "../../components/elements/Popover";
import { DEFAULT_POPOVER_WIDTH } from '../../constants';
import { InfoTooltipWrapper } from './InfoTooltipWrapper';
export var InfoTooltip = function (_a) {
    var data = _a.data, _b = _a.width, width = _b === void 0 ? DEFAULT_POPOVER_WIDTH : _b, autoWidth = _a.autoWidth, _c = _a.iconType, iconType = _c === void 0 ? 'help' : _c, onClick = _a.onClick, color = _a.color, fitted = _a.fitted, rest = __rest(_a, ["data", "width", "autoWidth", "iconType", "onClick", "color", "fitted"]);
    var _d = useState(null), anchor = _d[0], setAnchor = _d[1];
    var isOpen = anchor !== null;
    var handleMouseOver = function (event) {
        setAnchor(event.currentTarget);
    };
    var handleMouseLeave = function () {
        setAnchor(null);
    };
    var handleClick = function () { return onClick && onClick(); };
    var iconName = iconType === 'help' ? 'question-circle' : 'info-circle';
    return (React.createElement(InfoTooltipWrapper, { color: color },
        React.createElement(Icon, { name: iconName, size: "small", inheritColor: true, fitted: fitted, onMouseEnter: handleMouseOver, onMouseLeave: handleMouseLeave, onClick: handleClick }),
        React.createElement(Popover, __assign({ isOpen: isOpen, anchorElement: anchor, width: autoWidth ? undefined : width }, rest), data)));
};
